---
title: Nullish coalescing operator (??)
slug: Web/JavaScript/Reference/Operators/Nullish_coalescing_operator
tags:
  - JavaScript
  - Language feature
  - Operator
  - Reference
  - nullish coalescing
---
<p>{{JSSidebar("Operators")}}</p>

<p>The <strong>nullish coalescing operator (<code>??</code>)</strong> is a logical operator that returns its right-hand side operand when its left-hand side operand is {{jsxref("null")}} or {{jsxref("undefined")}}, and otherwise returns its left-hand side operand.</p>

<p>This can be contrasted with the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Logical_OR">logical OR (<code>||</code>) operator</a>, which returns the right-hand side operand if the left operand is <em>any</em> <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Logical_Operators#Description">falsy</a><em><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Logical_Operators#Description"> </a></em>value, not only <code>null</code> or <code>undefined</code>. In other words, if you use <code>||</code> to provide some default value to another variable <code>foo</code>, you may encounter unexpected behaviors if you consider some falsy values as usable (e.g., <code>''</code> or <code>0</code>). See below for more examples.</p>

<p>The nullish coalescing operator has the fifth-lowest <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Operator_Precedence">operator precedence</a>, directly lower than <code>||</code> and directly higher than the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Conditional_Operator">conditional (ternary) operator</a>.</p>

<div>{{EmbedInteractiveExample("pages/js/expressions-nullishcoalescingoperator.html")}}</div>

<p class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.<br>
 See <a href="https://github.com/mdn/interactive-examples/pull/1482#issuecomment-553841750">PR #1482</a> regarding the addition of this example.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>leftExpr</var> ?? <var>rightExpr</var>
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Using_the_nullish_coalescing_operator">Using the nullish coalescing operator</h3>

<p>In this example, we will provide default values but keep values other than <code>null</code> or <code>undefined</code>.</p>

<pre class="brush: js notranslate">const nullValue = null;
const emptyText = ""; // falsy
const someNumber = 42;

const valA = nullValue ?? "default for A";
const valB = emptyText ?? "default for B";
const valC = someNumber ?? 0;

console.log(valA); // "default for A"
console.log(valB); // "" (as the empty string is not null or undefined)
console.log(valC); // 42</pre>

<h3 id="Assigning_a_default_value_to_a_variable">Assigning a default value to a variable</h3>

<p>Earlier, when one wanted to assign a default value to a variable, a common pattern was to use the logical OR operator (<code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Logical_Operators#Logical_OR_2">||</a></code>):</p>

<pre class="brush: js notranslate">let foo;

//  foo is never assigned any value so it is still undefined
let someDummyText = foo || 'Hello!';</pre>

<p>However, due to <code>||</code> being a boolean logical operator, the left hand-side operand was coerced to a boolean for the evaluation and any <em>falsy</em> value (<code>0</code>, <code>''</code>, <code>NaN</code>, <code>null</code>, <code>undefined</code>) was not returned. This behavior may cause unexpected consequences if you consider <code>0</code>, <code>''</code>, or <code>NaN</code> as valid values.</p>

<pre class="brush: js notranslate">let count = 0;
let text = "";

let qty = count || 42;
let message = text || "hi!";
console.log(qty);     // 42 and not 0
console.log(message); // "hi!" and not ""
</pre>

<p>The nullish coalescing operator avoids this pitfall by only returning the second operand when the first one evaluates to either <code>null</code> or <code>undefined</code> (but no other falsy values):</p>

<pre class="brush: js notranslate">let myText = ''; // An empty string (which is also a falsy value)

let notFalsyText = myText || 'Hello world';
console.log(notFalsyText); // Hello world

let preservingFalsy = myText ?? 'Hi neighborhood';
console.log(preservingFalsy); // '' (as myText is neither undefined nor null)
</pre>

<h3 id="Short-circuiting">Short-circuiting</h3>

<p>Like the OR and AND logical operators, the right-hand side expression is not evaluated if the left-hand side proves to be neither <code>null</code> nor <code>undefined</code>.</p>

<pre class="brush: js notranslate">function A() { console.log('A was called'); return undefined;}
function B() { console.log('B was called'); return false;}
function C() { console.log('C was called'); return "foo";}

console.log( A() ?? C() );
// logs "A was called" then "C was called" and then "foo"
// as A() returned undefined so both expressions are evaluated

console.log( B() ?? C() );
// logs "B was called" then "false"
// as B() returned false (and not null or undefined), the right
// hand side expression was not evaluated
</pre>

<h3 id="No_chaining_with_AND_or_OR_operators">No chaining with AND or OR operators</h3>

<p>It is not possible to combine both the AND (<code>&amp;&amp;</code>) and OR operators (<code>||</code>) directly with <code>??</code>. A <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/SyntaxError">SyntaxError</a></code> will be thrown in such cases.</p>

<pre class="brush: js example-bad notranslate">null || undefined ?? "foo"; // raises a SyntaxError
true || undefined ?? "foo"; // raises a SyntaxError</pre>

<p>However, providing parenthesis to explicitly indicate precedence is correct:</p>

<pre class="brush: js example-good notranslate">(null || undefined) ?? "foo"; // returns "foo"
</pre>

<h3 id="Relationship_with_the_optional_chaining_operator_.">Relationship with the optional chaining operator (<code>?.</code>)</h3>

<p>The nullish coalescing operator treats <code>undefined</code> and <code>null</code> as specific values and so does the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Optional_chaining">optional chaining operator (<code>?.</code>)</a> which is useful to access a property of an object which may be <code>null</code> or <code>undefined</code>.</p>

<pre class="brush: js notranslate">let foo = { someFooProp: "hi" };

console.log(foo.someFooProp?.toUpperCase() ?? "not available"); // "HI"
console.log(foo.someBarProp?.toUpperCase() ?? "not available"); // "not available"
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#prod-CoalesceExpression', 'nullish coalescing expression')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.operators.nullish_coalescing")}}</p>

<h3 id="Implementation_Progress">Implementation Progress</h3>

<p>The following table provides a daily implementation status for this feature, because this feature has not yet reached cross-browser stability. The data is generated by running the relevant feature tests in <a href="https://github.com/tc39/test262">Test262</a>, the standard test suite of JavaScript, in the nightly build, or latest release of each browser's JavaScript engine.</p>

<div>{{EmbedTest262ReportResultsTable("coalesce-expression")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Optional_chaining">The optional chaining operator</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Logical_Operators#Logical_OR_2">The logical OR (<code>||</code>) operator</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Functions/Default_parameters">Default parameters in functions</a></li>
</ul>
